// ESP8266  Web client Example
// shield_FE with JTX to D8, JRX to D9, CS_PD not connect
// Tested with Shield_FE and module ESP8266-03 

// If using Software Serial for debug use the definitions below
//#include <SoftwareSerial.h>
//SoftwareSerial Debug(8,9);  // use pins 8, 9 for software serial 
//#define ESP8266 Serial

// If your MCU has dual USARTs (e.g. ATmega644 or Leonardo)
// Use the definitions below
//#define Debug Serial    // use Serial for debug
//#define ESP8266 Serial1   // use Serial1 to talk to esp8266

// If using Software Serial for comunicate with ESP
// Use the definitions below
#include <SoftwareSerial.h>
SoftwareSerial ESP8266(8,9);  // use pins 8, 9 for software serial 
#define Debug Serial


#define DEBUG true

#define SSID        "SSID"
#define PASS        "PASS"

#define DEST_HOST           "api.openweathermap.org"//"188.226.224.148"
#define DEST_PAGE           "/data/2.5/weather?id=3164699" 
#define DEST_PORT           80 	
//3164699	Varese
// "/data/2.5/forecast?id=524901"  //for forecast prevision


/*
#define DEST_HOST           "192.168.88.35"  //IP interno alla rete
#define DEST_PAGE           "/status.html HTTP"
#define DEST_PORT           80 
*/

/*
#define DEST_HOST           "wxdata.weather.com"
#define DEST_PAGE           "/wxdata/weather/local/ITXX0085?cc=*&unit=m"
#define DEST_PORT           80 
// ITXX0085 Venice, Italy
// ITXX0067 Rome, Italy
*/
/*
#define DEST_HOST           "www.google.com"
#define DEST_PAGE           "/ig/api?weather=12180"
#define DEST_PORT           80 
*/
/*
#define DEST_HOST           "weather.yahooapis.com"
#define DEST_PAGE           "/forecastrss?w=2367105"
#define DEST_PORT           80      
*/
/*
#define DEST_HOST           "developer.yahooapis.com"
#define DEST_PAGE           "/TimeService/V1/getTime?appid=YahooDemo"
#define DEST_PORT           80  
*/
/*
#define DEST_HOST           "www.timeapi.org"
#define DEST_PAGE           "/utc/now"
#define DEST_PORT           80    
*/
/*
#define DEST_HOST           "www.google.com"
#define DEST_PAGE           "/search?q=arduino"
#define DEST_PORT           80 
*/
/*
#define DEST_HOST           "www.google.com"
#define DEST_PAGE           "/finance?q=google"
#define DEST_PORT           80 
*/
/*
#define DEST_HOST           "www.adafruit.com"
#define DEST_PAGE           "/testwifi/index.html"
#define DEST_PORT           80 
*/


void setup()
{  
  // open Hardware Serial Port for communicate with PC
  Debug.begin(9600);  
  Debug.println("ESP8266 WebClient Demo");
  
  // Open Software Serial Port for communicate with EPS8266
  ESP8266.begin(9600); //it is the speed of ESP8266
  ESP8266.setTimeout(5000);  //timeout for receive response from ESP8266  
  
  //clear read buffer
  
  //test if the module is ready
  ESP8266.println("AT+RST");
  delay(1000);
  if (ESP8266.find("OK"))
  {
    Debug.println("Module is ready");
  }
  else
  {
    Debug.println("Module have no response.");
    while (1);
  }
  delay(1000);
  //connect to the wifi
  boolean connected = false;
  for (int i = 0; i < 5; i++)
  {
    if (connectWiFi())
    {
      connected = true;
      break;
    }
  }
  if (!connected) {
    while (1);
  }
  delay(5000);
 
  sendData("AT+CIPMUX=0\r\n",1000,DEBUG); // configure for multiple connections
  
  requestPage();
}



void loop()
{
  if (ESP8266.available())
    Debug.write(ESP8266.read()); 
  
}
 

int requestPage()
{
  String cmd = "AT+CIPSTART=\"TCP\",\"";
  cmd += DEST_HOST;
  cmd += "\",";
  cmd += DEST_PORT;
  cmd += "\r\n";
  
  sendData(cmd,2000,DEBUG);  

  cmd="";      
  //Define request string

  cmd =  "GET ";
  cmd += DEST_PAGE;
  cmd += " HTTP/1.0\r\nHost: ";
  cmd += DEST_HOST;
//  cmd += ":";
//  cmd += DEST_PORT;
  cmd += "\r\n\r\n";

    Debug.println(cmd);
    
    String cipsendcmd = "AT+CIPSEND=";
    cipsendcmd += cmd.length();
    cipsendcmd += "\r\n"; 
    ESP8266.print(cipsendcmd); 
         

   if(ESP8266.find(">"))
   {
     //Debug.println("found >");
   }
   else
   {
     ESP8266.println("AT+CIPCLOSE");
     Debug.println("connect timeout");
     return(0);
   }


  //SEND REQUEST
  ESP8266.print(cmd);
 
  //SEND OK
  if(ESP8266.find("SEND OK"))
  {
           Debug.println("Send request OK");
  }  
  else
  {
       Debug.println("Error send request!");
       return(0);
  }
 
 // read response 
 Debug.print("Receive:");  

}
 
String sendData(String command, const int timeout, boolean debug)
{
    String response = "";  
    ESP8266.print(command); // send the read character to the ESP8266    
    long int time = millis();    
    while( (time+timeout) > millis())
    {
      while(ESP8266.available())
      {      
        // The esp has data so display its output to the serial window 
        char c = ESP8266.read(); // read the next character.
        response+=c;
      }  
    }
    
    if(DEBUG) Debug.print(response);    
    return response;
}

boolean connectWiFi()
{
  ESP8266.println("AT+CWMODE=1");
  String cmd = "AT+CWJAP=\"";
  cmd += SSID;
  cmd += "\",\"";
  cmd += PASS;
  cmd += "\"";
  Debug.println(cmd);
  ESP8266.println(cmd);
  delay(2000);
  if (ESP8266.find("OK"))
  {
    Debug.println("OK, Connected to WiFi.");
    return true;
  } else
  {
    Debug.println("Can not connect to the WiFi.");
    return false;
  }
}
